<?php
/* ###################################################################

Contentpapst wurde von der sandoba.de medien agentur (www.sandoba.de) aus Berlin entworfen und unterliegt dem Urheberrecht. Jedwede nderung des Codes auerhalb der Lizenzrechte ist nicht erlaubt. Anfragen bitte an "contact@sandoba.de".

Website: www.sandoba.de
 sandoba.de medien agentur, 2002-2004

#################################################################### */

class contentpapst_gui_options extends contentpapst_options {

	var $module_configuration;
	var $module_language;

	/*
		class contentpapst_gui_options::contentpapst_gui_options
		Konstruktur, dient der Initialisierung der Klasse und einiger Variablen.
	*/

	function contentpapst_gui_options() {

		GLOBAL $file, $lang, $mode;

		$this->module_language = module_language($file) + $lang;

		$this->module_configuration["basics"] = array(
														"title"=>$this->module_language["$file"]["module_title"],
														"description"=>$this->module_language["$file"]["module_desc"]
												);

		$this->module_configuration["navigation"] = array(
														"main"=>array($this->module_language["main"]["overview"], "2", array()),
														"list_server"=>array($this->module_language["0090"], "2", array()),
														"list_metatags"=>array($this->module_language["main"]["metatags"], "2", array()),
														"list_general"=>array($this->module_language["main"]["options_general"], "2", array()),
														"list_speed"=>array($this->module_language["0590"], "2", array()),
														"list_cache"=>array($this->module_language["0540"], "2", array()),
														"list_logging"=>array($this->module_language["0805"], "2", array()),
														"service"=>array($this->module_language["0833"], "2", array()),
														"service_success"=>array($this->module_language["0833"], "2", array()),
														"list_contact"=>array($this->module_language["main"]["contact"], "2", array())
													);

		$this->module_configuration["functions"] = array(
														"main"=>array("do_main", array()),
														"list_server"=>array("do_list_server", array()),
														"list_contact"=>array("do_list_contact", array()),
														"set_contact"=>array("do_set_contact", array("form")),
														"list_metatags"=>array("do_list_metatags", array("form")),
														"set_metatags"=>array("do_set_metatags", array("form")),
														"list_general"=>array("do_list_general", array("form")),
														"set_general"=>array("do_set_general", array("form")),
														"list_speed"=>array("do_list_speed", array("form")),
														"list_cache"=>array("do_list_cache", array("form")),
														"delete_cache"=>array("do_delete_cache", array()),
														"set_cache"=>array("do_set_cache", array("form")),
														"list_logging"=>array("do_list_logging", array("form")),
														"list_logging_now"=>array("do_list_logging_now", array("form")),
														"set_logging"=>array("do_set_logging", array("form")),
														"delete_log"=>array("do_delete_log", array()),
														"service"=>array("do_service", array()),
														"service_email"=>array("do_service_email", array("form")),
														"service_success"=>array("do_service_success", array()),
														"modules"=>array("do_modules", array()),
														"install"=>array("do_install", array("module")),
														"add_bookmark"=>array("do_add_bookmark", array("url")),
														"add_bookmark_now"=>array("do_add_bookmark_now", array("form")),
														"delete_bookmark"=>array("do_delete_bookmark", array("number")),
														"set_active"=>array("do_set_active", array("form"))
													 );

		$this->module_configuration["rights"] = array(
														"all"=>array("options")
													 );

		if ($mode == "modules") {

			$this->module_configuration["basics"] = array(
														"title"=>$this->module_language["main"]["modules"],
														"description"=>$this->module_language["0097"]
													);

			$this->module_configuration["rights"] = array();

		} elseif ($mode == "add_bookmark") {

			$this->module_configuration["basics"] = array(
														"title"=>$this->module_language["0991"],
														"description"=>$this->module_language["1005"]
													);

		}

		if (in_array($mode, array("add_bookmark", "add_bookmark_now", "delete_bookmark"))) {
			$this->module_configuration["rights"] = array();
		}

	}

	/*
		class contentpapst_gui_options::install
		SQL- und Dateianweisungen zur Installation des Modules.
	*/

	function install() { }

	/*
		class contentpapst_gui_options::uninstall
		SQL- und Dateianweisungen zur Deinstallation des Modules.
	*/

	function uninstall() { }

	##################################################################

	/*
		class contentpapst_gui_options::do_add_bookmark
	*/

	function do_add_bookmark($url) {

		GLOBAL $PHP_SELF, $file;

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["1003"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";

		echo "<tr><td width=\"120\">".$this->module_language["main"]["title"].":</td><td>";
		form_text("form[title]", "input_10", "", "40");
		echo "</td></tr>";

		echo "<tr><td width=\"120\">".$this->module_language["main"]["url"].":</td><td>";
		echo "<input type=\"text\" class=\"input_10\" name=\"form[disabled_url]\" value=\"".stripslashes($url)."\" disabled=\"disabled\"/>";
		echo "</td></tr>";

		echo "<tr><td width=\"120\">".$this->module_language["0751"].":</td><td>";

		echo "<select name=\"form[target]\" class=\"inputsmall\">\n";
		echo "\t<option value=\"_self\" selected=\"selected\">".$this->module_language["1006"]."</option>\n";
		echo "\t<option value=\"_blank\">".$this->module_language["1007"]."</option>\n";
		echo "</select>\n";

		echo "</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "add_bookmark_now");
		form_hidden("form[url]", stripslashes($url));
		form_hidden("clean", "yes");

		form_send();
		echo "&nbsp;";

		form_reset($this->module_language["0780"]);
		form_stop();

		form_back("1");

	}

	/*
		class contentpapst_gui_options::do_add_bookmark_now
	*/

	function do_add_bookmark_now($form) {

		GLOBAL $PHP_SELF, $sql, $language, $log_number;

		db_insert("INSERT INTO ".$sql."_bookmarks VALUES('', '".$language."','".$log_number."','".$form["url"]."','".$form["target"]."','".$form["title"]."')");
		header("Location: $PHP_SELF");

	}

	/*
		class contentpapst_gui_options::do_delete_bookmark
	*/

	function do_delete_bookmark($number) {

		GLOBAL $sql, $language, $log_number;

		db_delete("DELETE FROM ".$sql."_bookmarks WHERE user = '".$log_number."' AND language = '".$language."' AND number = '".db_escape_string($number)."'");
		header("Location: ".getenv("HTTP_REFERER"));

	}

	/*
		class contentpapst_gui_options::do_install
	*/

	function do_install($module) {

		GLOBAL $PHP_SELF, $file, $sql;

		if ($module AND cp_module_exists($module)) {

			include("modules/".$module."/class.base.php");
			include("modules/".$module."/class.admin.php");
			@eval("\$this_class = new contentpapst_gui_".$module."();");
			sendsql("1", $this_class->install());

			$fd = @fopen("modules/".$module."/config.php","r");
			$contents = @fread($fd, filesize("modules/".$module."/config.php"));
			@fclose($fd);

			$contents = preg_replace("/\\\$module_config\[\"".$module."\"\]\[\"install\"\] = \"(.*){1}\";/iU","\$module_config[\"".$module."\"][\"install\"] = \"0\";",$contents);

			$contents = preg_replace("/\\\$module_config\[\"".$module."\"\]\[\"status\"\] = \"(.*){1,}\";/iU","\$module_config[\"".$module."\"][\"status\"] = \"1\";", $contents);

			$fd = @fopen("modules/".$module."/config.php", "w");
			@fwrite($fd, $contents);
			@fclose($fd);

			tabletop($this->module_language["0629"]);
			echo $this->module_language["0630"];
			tablefooter();
			echo "<br />";

			form_moveonsite("$PHP_SELF?file=$file&mode=modules", $this->module_language["button"]["next"], "2");

			set_db_config();

		} else {

			header("Location: $PHP_SELF?file=$file&mode=list_active");

		}

	}

	/*
		class contentpapst_gui_options::do_modules
	*/

	function do_modules() {

		include("config.php");
		include_once("functions/cp.string.php");

		GLOBAL $PHP_SELF, $file;

		$module_array = $this->get_modules("modules");
		$row_count = 0;

		$module_list = array();

		foreach($module_array AS $key => $value) {
			if (file_exists("modules/".$key."/languages/".$language."/index.php") AND $module_array["$key"]["show_list"] == "1" AND (file_exists("modules/".$key."/admin.php") OR file_exists("modules/".$key."/class.admin.php"))) {
				$module_list[] = $key;
			}
		}

		echo "<script type=\"text/javascript\">
		<!--

		function show_display(name) {
			if (ns) {
				document.layers['' + name].display = \"block\";
			} else {
				document.all['' + name].style.display = \"block\";
			}
		}

		function hide_display(name) {
			if (ns) {
				document.layers['' + name].display = \"none\";
			} else {
				document.all['' + name].style.display = \"none\";
			}
		}

		function show_module_info() {
		";

		foreach($module_list AS $key => $value) {
			echo "\t\tshow_display('module_".$value."');\n";
		}

		echo "}

		function hide_module_info() {
		";

		foreach($module_list AS $key => $value) {
			echo "\t\thide_display('module_".$value."');\n";
		}

		echo "}

		//-->

		</script>\n\n";

		tabletop($this->module_language["main"]["overview"]);

		echo $this->module_language["$file"]["0006"].": ";

		echo "<input type=\"radio\" name=\"module_info\" onclick=\"show_module_info()\"> <label for=\"show_module_info\">".$this->module_language["$file"]["0001"]."</label> ";

		echo "<input type=\"radio\" name=\"module_info\" onclick=\"hide_module_info()\" checked=\"checked\"> <label for=\"hide_module_info\">".$this->module_language["$file"]["0002"]."</label> ";

		if ($module_lines) {
			echo "<div style=\"margin-top: 6px; margin-bottom: 6px; border-bottom: 1px solid #B2BAC8;\"></div>";
		} else {
			echo "<br /><br />";
		}

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">";

		foreach($module_list AS $key => $value) {

			if ($row_count == 0) {
				echo "<tr>";
				$row_count = 0;
			}

			$row_count++;

			include("modules/".$value."/config.php");
			include_once("modules/".$value."/languages/".$language."/index.php");

			$module["title"] = $lang["$value"]["module_title"];
			$module["desc"] = $lang["$value"]["module_desc"];
			$module["desc"] = substr($module["desc"], 0, 150)."...";

			echo "<td valign=\"top\" width=\"150\">\n<table><tr><td height=\"250\" valign=\"top\">";

			if (file_exists("modules/".$value."/admin.php") OR file_exists("modules/".$value."/class.admin.php")) {
				$module["url"] = "admin.php";
			} else {
				$module["url"] = "index.php";
			}

			if ($module_config["$value"]["image"] AND file_exists($module_config["$value"]["image"])) {
				echo "<a href=\"".$module["url"]."?file=".$value."\" onfocus=\"this.blur()\"><img src=\"".$module_config["$value"]["image"]."\" border=\"0\" alt=\"\"/></a>\n<br /><br />\n";
			}

			echo "<div style=\"font-size: 12px; font-weight: bold\"><a href=\"".$module["url"]."?file=".$value."\" onfocus=\"this.blur()\">".$module["title"]."</a></div>\n<br />".$module["desc"]."\n";
			echo "</td></tr>\n<tr><td>\n\n";

			echo "<div id=\"module_".$value."\" style=\"display: none; padding: 2px; border: 1px solid #B2BAC8; background-color: #FFFFFF\" align=\"left\">\n";

			echo $this->module_language["$file"]["0007"].": ".$module_config["$value"]["version"]."<br />\n";
			echo $this->module_language["$file"]["0003"].": ".$module_config["$value"]["date"]."<br /><br />\n";
			echo cp_string_shorten($module_config["$value"]["author"], 25)."<br />\n";
			echo "<a href=\"mailto:".$module_config["$value"]["email"]."\">".cp_string_shorten($module_config["$value"]["email"],24)."</a><br />\n";
			echo "<a href=\"".$module_config["$value"]["website"]."\">".cp_string_shorten($module_config["$value"]["website"],24)."</a><br />\n";

			echo "</div>\n</td></tr></table><br />\n\n";

			echo "</td>\n\n";

			if ($row_count == 4) {
				echo "</tr>";

				if ($module_lines) {
					echo "<tr><td colspan=\"4\"><img src=\"themes/".$themeadmin."/images/cms_spacer.gif\" border=\"0\" width=\"100\" height=\"3\" alt=\"\"/><br /><div style=\"margin-bottom: 10px; border-bottom: 1px solid #B2BAC8;\"></div></td></tr>";
				}

				$row_count = 0;
			}

		}

		if ($row_count) {
			echo "</tr>";
		}

		echo "</table>";

		tablefooter();

	}

	/*
		class contentpapst_gui_options::do_service
	*/

	function do_service() {

		GLOBAL $PHP_SELF, $file, $configuration, $fullurl, $directory;

		tabletop($this->module_language["0834"]);
		echo $this->module_language["0835"]."<br /><br />";

		echo "<ul>\n";
		echo "\t<li type=\"square\">".$this->module_language["0837"].": <a href=\"http://www.sandoba.de/forum.html\" target=\"_blank\"><u>http://www.sandoba.de/forum.html</u></a></li>\n";
		echo "\t<li type=\"square\">".$this->module_language["0836"].": <a href=\"http://www.sandoba.de/article-section-6.html\" target=\"_blank\"><u>http://www.sandoba.de/article-section-6.html</u></a></li>\n";
		echo "\t<li type=\"square\">".$this->module_language["0838"].": <a href=\"http://www.sandoba.de/article-145-faq.html\" target=\"_blank\"><u>http://www.sandoba.de/article-145-faq.html</u></a></li>\n";
		echo "</ul>\n";

		tablefooter();
		echo "<br />";

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0832"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";

		echo "<tr><td width=\"100\">".$this->module_language["0577"].":</td><td align=\"left\">";
		form_text("form[forename]", "inputsubsmall", "", "60");
		echo "&nbsp;";
		form_text("form[surename]", "inputsubsmall", "", "60");
		echo "</td></tr>";

		echo "<tr><td width=\"100\">".$this->module_language["main"]["email"].":</td><td align=\"left\">";
		echo "<input type=\"text\" class=\"inputsmall\" name=\"form[email_disabled]\" value=\"".$configuration["main"]["email"]."\" disabled=\"disabled\"/>";
		echo "<input type=\"hidden\" name=\"form[email]\" value=\"".$configuration["main"]["email"]."\"/>";
		echo "</td></tr>";

		echo "<tr><td width=\"100\">".$this->module_language["main"]["url"].":</td><td align=\"left\">";
		echo "<input type=\"text\" class=\"inputsmall\" name=\"form[url_disabled]\" value=\"".$fullurl."\" disabled=\"disabled\"/>";
		echo "<input type=\"hidden\" name=\"form[url]\" value=\"".$fullurl.$directory."\"/>";
		echo "</td></tr>";

		echo "<tr><td width=\"100\">".$this->module_language["main"]["phone"].":</td><td align=\"left\">";
		form_text("form[phone]", "inputsmall", "", "60");
		echo "&nbsp;";
		form_checkbox("form[call_back]", "1", "0", "call_back");
		echo "<label for=\"call_back\">".$this->module_language["0831"]."</label>";
		echo "</td></tr>";

		echo "<tr><td colspan=\"2\" height=\"10\"></td></tr>";

		echo "<tr><td width=\"100\">".$this->module_language["0361"].":</td><td align=\"left\">";
		echo "<input type=\"text\" class=\"inputsmall\" name=\"form[title]\" value=\"".$this->do_service_text()."\" style=\"width: 502px\" maxlength=\"100\"/>";
		echo "</td></tr>";

		echo "<tr><td colspan=\"2\">";
		form_textarea("form[text]", "inputfull", "10", "");
		echo "</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "service_email");
		form_hidden("clean", "yes");

		form_send();
		form_stop();

	}

	/*
		class contentpapst_gui_options::do_service_text
	*/

	function do_service_text() {

		GLOBAL $action, $systemversion, $systemname, $version;

		if ($action == "update" AND $version) {
			RETURN "Update von ".$systemname." Version ".$systemversion." auf Version ".$version;
		} else {
			RETURN;
		}

	}

	/*
		class contentpapst_gui_options::do_service_email
	*/

	function do_service_email($form) {

		include("config.php");
		include_once("functions/cp.statistic.php");

		GLOBAL $PHP_SELF, $file;

		if ($form) {

			$form["text"] = stripslashes($form["text"]);

			$string = $this->module_language["0839"]." ".ucfirst($form["forename"])." ".ucfirst($form["surename"])."\r\n";
			$string .= "----------------------------------------\r\n\r\n";

			$string .= $this->module_language["main"]["name"].": ".ucfirst($form["forename"])." ".ucfirst($form["surename"])."\r\n";
			$string .= $this->module_language["main"]["email"].": ".$form["email"]."\r\n";

			if ($form["phone"]) {
				$string .= $this->module_language["main"]["phone"].": ".$form["phone"]."\r\n";
			}

			if ($form["call_back"]) {
				$string .= $this->module_language["0831"].": ".$this->module_language["yes"]."\r\n";
			} else {
				$string .= $this->module_language["0831"].": ".$this->module_language["no"]."\r\n";
			}

			if ($form["url"]) {
				$string .= $this->module_language["main"]["url"].": ".$form["url"]."\r\n";
			}

			$string .= "\r\n----------------------------------------\r\n\r\n";
			$string .= trim($form["text"])."\r\n\r\n";
			$string .= "----------------------------------------\r\n\r\n";
			$string .= "PHP-Version: ".phpversion()."\r\n";

			$user_info = cp_statistic_info();

			if ($user_info["javascript"]) {
				$user_info["javascript"] = $this->module_language["yes"];
			} else {
				$user_info["javascript"] = $this->module_language["no"];
			}

			$string .= $this->module_language["main"]["os"].": ".$user_info["os"]."\r\n";
			$string .= $this->module_language["main"]["browser"].": ".$user_info["browser"]."\r\n";
			$string .= $this->module_language["0755"].": ".$user_info["javascript"]."\r\n";

			$string .= "\r\n----------------------------------------\r\n\r\n";
			$string .= $this->module_language["0840"];

			$email_title = $this->module_language["0839"]." ".ucfirst($form["forename"])." ".ucfirst($form["surename"]);

			@mail($email_administrator, $email_title, $string, "From: ".$form["email"]);

			header("Location: $PHP_SELF?file=$file&mode=service_success");

		} else {

			header("Location: $PHP_SELF?file=$file&mode=service");

		}

	}

	/*
		class contentpapst_gui_options::do_service_success
	*/

	function do_service_success() {

		GLOBAL $PHP_SELF;

		tabletop($this->module_language["0832"]);
		echo $this->module_language["0841"];
		tablefooter();
		echo "<br />";

		form_moveon("$PHP_SELF");

	}

	/*
		class contentpapst_gui_options::do_list_contact
	*/

	function do_list_contact($form) {

		GLOBAL $PHP_SELF, $file, $configuration;

		$tablewidth = "130";

		$fields = array(
					array("email", $this->module_language["0482"]),
					array("email_webmaster", $configuration["main"]["email_webmaster"]),
					array("email_support", $this->module_language["0484"])
				  );

		js_check("options_contact", $fields, $this->module_language["0589"]);

		form_start("$PHP_SELF?file=$file", "post", "options_contact");

		tabletop($this->module_language["main"]["contact"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\"><tr><td width=\"$tablewidth\">".$this->module_language["0482"].":</td><td>";
		form_text("form[main][email]", "inputnormal", $configuration["main"]["email"], "100", "email");
		echo "</td></tr><tr><td width=\"$tablewidth\">".$this->module_language["0483"].":</td><td>";
		form_text("form[main][email_webmaster]", "inputnormal", $configuration["main"]["email_webmaster"], "100", "email_webmaster");
		echo "</td></tr><tr><td width=\"$tablewidth\">".$this->module_language["0484"].":</td><td>";
		form_text("form[main][email_support]", "inputnormal", $configuration["main"]["email_support"], "100", "email_support");
		echo "</td></tr></table>";

		tablefooter();

		form_hidden("mode", "set_contact");
		echo "<br />";

		form_send("return check_form()", "1");
		form_stop();

		form_moveon("$PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_set_contact
	*/

	function do_set_contact($form) {

		GLOBAL $PHP_SELF, $file, $sql;

		$rights_array = array("company", "genre", "job", "street", "city", "country", "tel", "fax", "howfound", "comment", "newsletter", "url");

		foreach ($rights_array AS $key => $value) {
			if (!$form["options"]["$value"]) {
				$form["options"]["$value"] = "0";
			}
		}

		foreach($form["options"] AS $key => $value) {

			if (!$value AND !in_array($key, $full_array)) {
				$value = "0";
			}

			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'contact'");
		}

		foreach($form["main"] AS $key => $value) {

			if (!$value AND !in_array($key,$full_array)) {
				$value = "0";
			}

			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'main'");
		}

		set_db_config();
		setconfig();

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_list_server
	*/

	function do_list_server($form) {

		include_once("functions/cp.string.php");
		GLOBAL $PHP_SELF, $file, $HTTP_SERVER_VARS;

		$tablewidth = "130";

		tabletop($this->module_language["0090"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

		echo "<tr><td width=\"$tablewidth\"><strong>".$this->module_language["main"]["date"].":</strong></td><td>".date("d.m.Y")." (TT.MM.JJ)</td></tr>";
		echo "<tr><td width=\"$tablewidth\"><strong>".$this->module_language["0536"].":</strong></td><td>".date("H:i:s")."</td></tr>";
		echo "<tr><td width=\"$tablewidth\"><strong>".$this->module_language["0100"].":</strong></td><td>".phpversion()."</td></tr>";

		foreach ($HTTP_SERVER_VARS AS $key => $value) {
			echo "<tr><td width=\"".$tablewidth."\"><strong>".$key.":</strong></td><td>".cp_string_shorten($value, 80)."</td></tr>";
		}

		echo "</table>";

		tablefooter();

		echo "<br />";
		form_moveon("$PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_list_metatags
	*/

	function do_list_metatags($form="") {

		GLOBAL $PHP_SELF, $file, $sql, $configuration;

		$tablewidth = "130";

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0947"]);
		echo $this->module_language["0948"]."<br /><br />";

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["main"]["title"].":</strong><br />({cp:meta:title})</td><td valign=\"top\">";
		form_text("form[meta_title]", "inputbig", $configuration["main"]["meta_title"], "70");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["main"]["description"].":</strong><br />({cp:meta:description})</td><td>";
		form_textarea("form[meta_description]", "inputbig", "5", $configuration["main"]["meta_description"]);
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["main"]["keywords"].":</strong><br />({cp:meta:keywords})</td><td>";
		form_textarea("form[meta_keywords]", "inputbig", "5", $configuration["main"]["meta_keywords"]);
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["main"]["copyright"].":</strong><br />({cp:meta:copyright})</td><td>";
		form_text("form[meta_copyright]", "inputbig", $configuration["main"]["meta_copyright"], "80");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["main"]["author"].":</strong><br />({cp:meta:author})</td><td>";
		form_text("form[meta_author]", "inputbig", $configuration["main"]["meta_author"], "80");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["0538"].":</strong><br />({cp:meta:publisher})</td><td>";
		form_text("form[meta_publisher]", "inputbig", $configuration["main"]["meta_publisher"], "80");
		echo "</td></tr>";

		$robot_commands = array(
												"index,follow"=>$this->module_language["main"]["robots_1"],
												"noindex,nofollow"=>$this->module_language["main"]["robots_2"],
												"index,nofollow"=>$this->module_language["main"]["robots_3"],
												"noindex,follow"=>$this->module_language["main"]["robots_4"]
										 );

		echo "<tr><td width=\"100\"><strong>".$this->module_language["main"]["robots"].":</strong><br />({cp:meta:robots})</td><td>\n\n";

		if (!$configuration["main"]["meta_robots"]) {
			$configuration["main"]["meta_robots"] = "index,follow";
		}

		echo "<select name=\"form[meta_robots]\" class=\"inputnormal\">\n";

		foreach ($robot_commands AS $key => $value) {

			unset($selected);

			if ($configuration["main"]["meta_robots"] == $key) {
				$selected = " selected=\"selected\"";
			}

			echo "\t<option value=\"".$key."\"".$selected.">".$value."</option>\n";
		}

		echo "</select>\n\n";
		echo "</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "set_metatags");

		form_send();
		form_stop();

		echo "<br /><br />";

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0946"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

		echo "<tr><td width=\"$tablewidth\" valign=\"top\"><strong>".$this->module_language["main"]["description"].":</strong></td><td>";
		form_textarea("form[description]", "inputbig", "3", $form["description"]);
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\"><strong>".$this->module_language["main"]["keywords"].":</strong><br />".$this->module_language["main"]["keywordssep"]."</td><td>";
		form_text("form[keywords]", "inputbig", $form["keywords"], "100");
		echo "</td></tr>";

		echo "<tr><td colspan=\"2\"><br /></td></tr>";
		echo "<tr><td colspan=\"2\"><strong>".$this->module_language["main"]["additional"].":</strong></td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["author"].":</td><td>";
		form_text("form[author]", "inputbig", $form["author"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["language"].":</td><td>";
		form_text("form[language]", "inputsubsmall", $form["language"], "30");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["robots"].":</td><td>\n\n";
		echo "<select name=\"form[robots]\" class=\"inputnormal\">\n";
		echo "\t<option value=\"index,follow\">".$this->module_language["main"]["robots_1"]."</option>\n";
		echo "\t<option value=\"noindex,nofollow\">".$this->module_language["main"]["robots_2"]."</option>\n";
		echo "\t<option value=\"index,nofollow\">".$this->module_language["main"]["robots_3"]."</option>\n";
		echo "\t<option value=\"noindex,follow\">".$this->module_language["main"]["robots_4"]."</option>\n";
		echo "</select>\n\n";
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["copyright"].":</td><td>";
		form_text("form[copyright]", "inputbig", $form["copyright"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0538"].":</td><td>";
		form_text("form[publisher]", "inputbig", $form["publisher"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0539"].":</td><td>";
		form_text("form[content_type]", "inputbig", $form["content_type"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["topic"].":</td><td>";
		form_text("form[page_topic]", "inputbig", $form["page_topic"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0543"].":</td><td>";
		form_text("form[page_type]", "inputbig", $form["page_type"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["email"].":</td><td>";
		form_text("form[email]", "inputbig", $form["email"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0292"].":</td><td>";
		form_text("form[date]", "inputbig", $form["date"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["revisit"].":</td><td>\n\n";
		echo "<select name=\"form[revisittime]\" class=\"inputmini\">\n";
		echo "\t<option value=\"5\">5 ".$this->module_language["main"]["days"]."</option>\n";
		echo "\t<option value=\"10\">10 ".$this->module_language["main"]["days"]."</option>\n";
		echo "\t<option value=\"15\">15 ".$this->module_language["main"]["days"]."</option>\n";
		echo "\t<option value=\"20\">20 ".$this->module_language["main"]["days"]."</option>\n";
		echo "\t<option value=\"25\">25 ".$this->module_language["main"]["days"]."</option>\n";
		echo "\t<option value=\"30\">30 ".$this->module_language["main"]["days"]."</option>\n";
		echo "</select>\n";
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0540"].":</td><td>\n\n";
		echo "<select name=\"form[cache]\" class=\"inputmini\">\n";
		echo "\t<option value=\"0\">".$this->module_language["0541"]."</option>\n";
		echo "\t<option value=\"1\">".$this->module_language["0542"]."</option>\n";
		echo "</select>\n\n";
		echo "</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "list_metatags");
		form_send();
		form_stop();

		echo "&nbsp;";

		if ($form) {
			form_back("1");
		} else {
			form_moveon("$PHP_SELF?file=$file");
		}

		if ($form) {

			echo "<br /><br />";

			unset($meta_str);
			tabletop($this->module_language["0946"]);

			echo $this->module_language["0511"]."<br /><br />";

			if ($form["description"]) {
				$meta_str .= "&LT;meta name=\"description\" content=\"".$form["description"]."\"/&GT;\n";
			}

			if ($form["keywords"]) {
				$meta_str .= "&LT;meta name=\"keywords\" content=\"".$form["keywords"]."\"/&GT;\n";
			}

			if ($form["email"]) {
				$meta_str .= "&LT;meta name=\"reply-to\" content=\"".$form["email"]."\"/&GT;\n";
			}

			if ($form["author"]) {
				$meta_str .= "&LT;meta name=\"author\" content=\"".$form["author"]."\"/&GT;\n";
			}

			if ($form["page_type"]) {
				$meta_str .= "&LT;meta name=\"page-type\" content=\"".$form["page_type"]."\"/&GT;\n";
			}

			if ($form["date"]) {
				$meta_str .= "&LT;meta name=\"date\" content=\"".$form["date"]."\"/&GT;\n";
			}

			if ($form["robots"]) {
				$meta_str .= "&LT;meta name=\"robot\" content=\"".$form["robots"]."\"/&GT;\n";
			}

			if ($form["publisher"]) {
				$meta_str .= "&LT;meta name=\"publisher\" content=\"".$form["publisher"]."\"/&GT;\n";
			}

			if ($form["content_type"]) {
				$meta_str .= "&LT;meta name=\"content-type\" content=\"".$form["content_type"]."\"/&GT;\n";
			}

			if ($form["page_topic"]) {
				$meta_str .= "&LT;meta name=\"page-topic\" content=\"".$form["page_topic"]."\"/&GT;\n";
			}

			if ($form["language"]) {
				$meta_str .= "&LT;meta name=\"language\" content=\"".$form["language"]."\"/&GT;\n";
			}

			if ($form["copyright"]) {
				$meta_str .= "&LT;meta name=\"copyright\" content=\"".$form["copyright"]."\"/&GT;\n";
			}

			if ($form["revisittime"]) {
				$meta_str .= "&LT;meta name=\"revisit-after\" content=\"".$form["revisittime"]."\"/&GT;\n";
			}

			if ($form["cache"]) {
				$meta_str .= "&LT;meta http-equiv=\"Pragma\" content=\"no-cache\"/&GT;\n";
				$meta_str .= "&LT;meta http-equiv=\"Cache-Control\" content=\"no-cache\"/&GT;\n";
				$meta_str .= "&LT;meta http-equiv=\"expires\" content=\"0\"/&GT;\n";
				$meta_str .= "&LT;meta http-equiv=\"expires\" content=\"new\"/&GT;\n";
			}

			form_textarea("form[comment]", "inputfull", "8", trim($meta_str));

			tablefooter();
			echo "<br />";

		}

	}

	/*
		class contentpapst_gui_options::do_set_metatags
	*/

	function do_set_metatags($form) {

		GLOBAL $PHP_SELF, $file, $sql;

		$full_array = array();

		foreach($form AS $key => $value) {

			if (!$value AND in_array($key, $full_array)) {
				$value = "0";
			}

			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'main'");
		}

		set_db_config();
		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_list_general
	*/

	function do_list_general() {

		include_once("functions/cp.files.php");
		include("themes/backend/style.php");
		GLOBAL $PHP_SELF, $file, $sql, $configuration, $themeadmin, $language;

		$tablewidth = "130";

		$fields = array(
					array("title", $this->module_language["0467"]),
					array("fullurl", $this->module_language["0468"]),
					array("date", $this->module_language["main"]["date"]),
					array("dateshort", $this->module_language["main"]["date"]." (".$this->module_language["0471"].")")
				  );

		js_check("options_general", $fields, $this->module_language["0589"]);

		form_start("$PHP_SELF?file=$file", "post", "options_general");

		tabletop($this->module_language["main"]["options_general"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0467"].":</td><td>";
		form_text("form[title]", "inputnormal", $configuration["main"]["title"], "100", "title");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0468"].":</td><td>";
		form_text("form[fullurl]", "inputsmall", $configuration["main"]["fullurl"], "100", "fullurl");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0469"].":</td><td>";
		form_text("form[directory]", "inputsmall", $configuration["main"]["directory"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0470"].":</td><td>";
		form_text("form[images]", "inputsmall", $configuration["main"]["images"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0943"].":</td><td>";
		form_text("form[gzip_compress]", "input_1", $configuration["main"]["gzip_compress"], "1");
		echo "&nbsp;".$this->module_language["0944"]."</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["date"].":</td><td>";
		form_text("form[date]", "inputsmall", $configuration["main"]["date"], "100", "date");
		echo "<a href=\"admin.php?file=help&mode=section&number=7\"><img src=\"themes/$themeadmin/images/button_help.gif\" border=\"0\" alt=\"\"/></a></td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["date"]." (".$this->module_language["0471"]."):</td><td>";
		form_text("form[dateshort]", "inputsmall", $configuration["main"]["dateshort"], "100", "dateshort");
		echo "<a href=\"admin.php?file=help&mode=section&number=7\"><img src=\"themes/$themeadmin/images/button_help.gif\" border=\"0\" alt=\"\"/></a></td></tr>";

		echo "<tr><td width=\"100\">".$this->module_language["0082"].":</td><td>\n\n";

		echo "<select name=\"form[deflang]\" class=\"inputsmall\">\n";

		if (!$language) {

			echo "\t<option value=\"\">".$this->module_language["main"]["choose"]."</option>\n";
			echo "\t<option value=\"\">--------------------------</option>\n";

		}

		$files = new contentpapst_files();
		$array = $files->list_dirs("languages");
		unset($array["0"]);

		foreach ($array AS $key => $value) {

			$value = str_replace("languages/", "", $value);
			unset($selected);

			if ($value == $language) {
				$selected = " selected=\"selected\"";
			}

			echo "\t<option value=\"".$value."\"".$selected.">".strtoupper($value)." - ".cp_lang_info($value)."</option>\n";

		}

		echo "</select>\n\n";

		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0539"].":</td><td>";
		echo "<input type=\"text\" class=\"inputsmall\" name=\"form[disabled_charset]\" disabled=\"disabled\" value=\"".$configuration["main"]["charset"]."\"/>";
		echo "</td></tr>";

		echo "</table>";

		$col_width = "20";

		echo "</td></tr><tr><td colspan=\"2\" bgcolor=\"$blockback\" height=\"10\"> </td></tr>
		<tr><td colspan=\"2\" bgcolor=\"$bordercolor\" height=\"2\"> </td></tr><tr><td colspan=\"2\" class=\"table_bottom\">";

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		if ($configuration["main"]["mod_rewrite"]) {
			form_checkbox("form[mod_rewrite]", "1", "1");
			form_hidden("form[mod_rewrite_old]", "1");
		} else {
			form_checkbox("form[mod_rewrite]", "1", "0");
			form_hidden("form[mod_rewrite_old]", "0");
		}

		echo "</td><td align=\"left\"><strong>".$this->module_language["$file"]["0017"]."</strong><br />".$this->module_language["$file"]["0018"]."</td></tr>";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		if ($configuration["main"]["last_modified"]) {
			form_checkbox("form[last_modified]", "1", "1");
		} else {
			form_checkbox("form[last_modified]", "1", "0");
		}

		echo "</td><td align=\"left\"><strong>".$this->module_language["0994"]."</strong><br />".$this->module_language["0995"]."</td></tr>";

		echo "</table>";

		tablefooter();

		form_hidden("mode", "set_general");

		echo "<br />";

		form_send("return check_form()", "1");
		form_stop();

		form_moveon("$PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_set_general
	*/

	function do_set_general($form) {

		include_once("functions/cp.misc.php");
		GLOBAL $PHP_SELF, $file, $sql;

		$rights_array = array("show_banner", "recursive_delete", "file_size", "sha1_support", "mod_rewrite", "gzip_compress", "filter_links", "last_modified");
		$full_array = array("images", "date", "dateshort", "deflang", "title", "fullurl", "directory", "recursive_delete");

		$form["charset"] = cp_get_charset($form["deflang"]);

		if ($form["fullurl"]) {
			if (substr(strrev($form["fullurl"]), 0, 1) != "/") {
				$form["fullurl"] .= "/";
			}
		}

		if ($form["directory"]) {
			if (substr(strrev($form["directory"]), 0, 1) != "/") {
				$form["directory"] .= "/";
			}
		}

		if ($form["delete_management"]) {

			$form["delete_check"] = 1;
			$form["delete_dirs"] = 1;
			unset($form["delete_management"]);

		} else {

			$form["delete_check"] = 0;
			$form["delete_dirs"] = 0;
			unset($form["delete_management"]);

		}

		if (!$form["gzip_compress"]) {
			$form["gzip_compress"] = 5;
		}

		foreach ($rights_array AS $key => $value) {
			if (!$form["$value"]) {
				$form["$value"] = "0";
			}
		}

		if ($form["mod_rewrite"] AND !$form["mod_rewrite_old"]) {

			@chmod(".htaccess", 0777);

			$fp = @fopen(".htaccess", "r");
			$content = @fread($fp, filesize(".htaccess"));
			@fclose($fp);

			if (!preg_match("/cp:rewrite_engine/", $content)) {

				$content = trim($content)."\r\n".str_replace("\t", "", $this->mod_rewrite());

				$fd = @fopen(".htaccess", "wb");
				@fwrite($fd, $content);
				@fclose($fd);

			}

		} elseif (!$form["mod_rewrite"] AND $form["mod_rewrite_old"]) {

			@chmod(".htaccess", 0777);

			$fp = @fopen(".htaccess", "r");
			$content = @fread($fp, filesize(".htaccess"));
			@fclose($fp);

			$content = preg_replace("/\# <cp:rewrite_engine>([^\#]*)\# <\/cp:rewrite_engine>/iU", "", $content);

			$fd = @fopen(".htaccess", "w");
			@fwrite($fd, trim($content));
			@fclose($fd);

		}

		foreach($form AS $key => $value) {

			if (!$value AND !in_array($key, $full_array)) {
				$value = "0";
			}

			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'main'");
		}

		set_db_config();
		setconfig();

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::mod_rewrite
	*/

	function mod_rewrite() {

		GLOBAL $directory;

		$content = "
		# <cp:rewrite_engine>

		RewriteEngine on
		Options +FollowSymlinks
		Options +SymLinksIfOwnerMatch
		RewriteBase /".$directory."

		RewriteRule ^article-([0-9]+)-([a-zA-Z0-9-]+)\.html \index.php?id=$1&mod_rewrite=1 [L]
		RewriteRule ^article-(section|entry)-([0-9]+)-([0-9]+)\.html \index.php?file=article&mode=$1&number=$2&page=$3&mod_rewrite=1 [L]
		RewriteRule ^article-(section|entry)-([0-9]+)\.html \index.php?file=article&mode=$1&number=$2&mod_rewrite=1 [L]
		RewriteRule ^banner-([0-9]+)-([0-9]+)\.html \index.php?file=ads&mode=show&clicked=$1&url=$2&mod_rewrite=1 [L]
		RewriteRule ^forum-section-([0-9]+)\.html \index.php?file=forum&section=$1&mod_rewrite=1 [L]
		RewriteRule ^links-detail-([0-9]+)\.html \index.php?file=links&mode=$1&number=$2&mod_rewrite=1 [L]
		RewriteRule ^login\.html \index.php?mode=user [L]
		RewriteRule ^logout\.html \loginset.php?mode=logout [L]
		RewriteRule ^member\.(php|html) \index.php?file=user&mod_rewrite=1 [L]
		RewriteRule ^news-(category|detail)-([0-9]+)\.html \index.php?file=news&mode=$1&number=$2&mod_rewrite=1 [L]
		RewriteRule ^newsfeed.(food|klip|xml)\.html \index.php?file=webservices&mode=newsfeed_$1&clean=yes&mod_rewrite=1 [L]
		RewriteRule ^newsletter-(read|url)-([0-9]+)\.html \index.php?file=newsletter&mode=$1&number=$2&mod_rewrite=1 [L]
		RewriteRule ^print-([a-z]+)-([0-9]+)-([0-1]+)\.html \print.php?get=$1&number=$2&cp_content_parse=$3 [L]
		RewriteRule ^print-([a-z]+)\.html \print.php?get=$1 [L]
		RewriteRule ^search-(.*)-(.*)-([0-9]+)\.html \index.php?file=search&mode=search&q=$1&category=$2&form[page]=$3&mod_rewrite=1 [L]
		RewriteRule ^shop-section-([0-9]+)\.html \index.php?file=shop&section=$1&mod_rewrite=1 [L]
		RewriteRule ^shop-partner-(.*)\.html \index.php?file=shop&partner=$1&mod_rewrite=1 [L]
		RewriteRule ^shop-(add|details)-([0-9]+)\.html \index.php?file=shop&mode=$1&number=$2&mod_rewrite=1 [L]
		RewriteRule ^shop-([a-z_-]+)\.html \index.php?file=shop&mode=$1&mod_rewrite=1 [L]
		RewriteRule ^user-([0-9]+)\.html \index.php?file=user&mode=profil&number=$1&mod_rewrite=1 [L]
		RewriteRule ^index\.html \index.php?mod_rewrite=1 [L]
		RewriteRule ^([a-z]+)\.html \index.php?file=$1&mod_rewrite=1 [L]

		# </cp:rewrite_engine>
		";

		RETURN $content;

	}

	/*
		class contentpapst_gui_options::do_list_search
	*/

	function do_list_search() {

		GLOBAL $PHP_SELF, $file, $sql, $configuration;

		$tablewidth = "170";

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0560"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0567"].":</td><td>";
		form_text("form[min_length]", "inputsub", $configuration["search"]["min_length"], "3");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0566"].":</td><td>";
		form_text("form[max_length]", "inputsub", $configuration["search"]["max_length"], "3");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0563"].":</td><td>";

		if ($configuration["search"]["highlight_results"]) {
			form_radio("form[highlight_results]", 1, 1, "highlight_1");
		} else {
			form_radio("form[highlight_results]", 1, 0, "highlight_1");
		}

		echo "&nbsp;<label for=\"highlight_1\">".$this->module_language["yes"]."</label>";

		if (!$configuration["search"]["highlight_results"]) {
			form_radio("form[highlight_results]", 0, 1, "highlight_0");
		} else {
			form_radio("form[highlight_results]", 0, 0, "highlight_0");

		}
		echo "&nbsp;<label for=\"highlight_0\">".$this->module_language["no"]."</label>";

		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0564"].":</td><td>";
		form_text("form[highlight_color]", "inputsub", $configuration["search"]["highlight_color"], "6");
		echo "&nbsp;(".$this->module_language["0565"].")";
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0562"].":</td><td>";
		form_text("form[per_page]", "inputsub", $configuration["search"]["per_page"], "3");
		echo "";
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0561"].":</td><td>";

		if ($configuration["search"]["spell_check"]) {
			form_radio("form[spell_check]", 1, 1, "spell_check_1");
		} else {
			form_radio("form[spell_check]", 1, 0, "spell_check_1");
		}

		echo "&nbsp;<label for=\"spell_check_1\">".$this->module_language["yes"]."</label>";

		if (!$configuration["search"]["spell_check"]) {
			form_radio("form[spell_check]", 0, 1, "spell_check_0");
		} else {
			form_radio("form[spell_check]", 0, 0, "spell_check_0");
		}

		echo "&nbsp;<label for=\"spell_check_0\">".$this->module_language["no"]."</label>";

		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0633"].":</td><td>";

		if ($configuration["search"]["ignore_stopwords"]) {
			form_radio("form[ignore_stopwords]", 1, 1, "ignore_stopwords_1");
		} else {
			form_radio("form[ignore_stopwords]", 1, 0, "ignore_stopwords_1");
		}

		echo "&nbsp;<label for=\"ignore_stopwords_1\">".$this->module_language["yes"]."</label>";

		if (!$configuration["search"]["ignore_stopwords"]) {
			form_radio("form[ignore_stopwords]", 0, 1, "ignore_stopwords_0");
		} else {
			form_radio("form[ignore_stopwords]", 0, 0, "ignore_stopwords_0");
		}

		echo "&nbsp;<label for=\"ignore_stopwords_0\">".$this->module_language["no"]."</label>";

		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0634"].":</td><td>";

		if ($configuration["search"]["ignore_symbols"]) {
			form_radio("form[ignore_symbols]", 1, 1, "ignore_symbols_1");
		} else {
			form_radio("form[ignore_symbols]", 1, 0, "ignore_symbols_1");
		}

		echo "&nbsp;<label for=\"ignore_symbols_1\">".$this->module_language["yes"]."</label>";

		if (!$configuration["search"]["ignore_symbols"]) {
			form_radio("form[ignore_symbols]", 0, 1, "ignore_symbols_0");
		} else {
			form_radio("form[ignore_symbols]", 0, 0, "ignore_symbols_0");
		}

		echo "&nbsp;<label for=\"ignore_symbols_0\">".$this->module_language["no"]."</label>";

		echo "</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "set_search");

		form_send();
		form_stop();

		echo "&nbsp;";

		form_moveon("$PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_set_search
	*/

	function do_set_search($form) {

		GLOBAL $PHP_SELF, $file, $sql;

		$rights_array = array("min_length", "max_length", "highlight_results", "highlight_color", "per_page", "spell_check", "ignore_symbols", "ignore_stopwords");

		foreach ($rights_array AS $key => $value) {
			if (!$form["$value"]) {
				$form["$value"] = "0";
			}
		}

		foreach($form AS $key => $value) {

			if (!$value) {
				$value = "0";
			}

			if ($key == "highlight_color" AND !$value) {
				$value = "000000";
			}

			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'search'");
		}

		set_db_config();
		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_list_speed
	*/

	function do_list_speed($form="") {

		GLOBAL $PHP_SELF, $file, $sql;

		$tablewidth = "130";

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0590"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

		echo "<tr><td colspan=\"2\">".$this->module_language["0591"]."<br /><br /></td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["main"]["url"].":</td><td>";
		form_text("form[url]", "inputbig", $form["url"], "100");
		echo "</td></tr>";

		echo "<tr><td width=\"$tablewidth\">".$this->module_language["0593"].":</td><td>\n\n";
		echo "<select name=\"form[relaunch]\" class=\"inputmini\">\n";
		echo "\t<option value=\"1\">1</option>\n";
		echo "\t<option value=\"3\">3</option>\n";
		echo "\t<option value=\"5\">5</option>\n";
		echo "\t<option value=\"10\">10</option>\n";
		echo "\t<option value=\"20\">20</option>\n";
		echo "\t<option value=\"40\">40</option>\n";
		echo "\t<option value=\"60\">60</option>\n";
		echo "\t<option value=\"10\">100</option>\n";
		echo "</select>\n\n";
		echo "</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "list_speed");
		form_send();
		form_stop();

		echo "&nbsp;";

		if ($form) {
			form_back("1");
		} else {
			form_moveon("$PHP_SELF?file=$file");
		}

		if ($form) {

			echo "<br /><br />";

			$fp = @fopen($form["url"],"r");

			tabletop($this->module_language["0592"]);

			if ($fp) {

				$time_start = microtime();
				$url["size"] = @filesize($form["url"]);

				for ($a = 0; $a < $form["relaunch"]; $a++) {

					$fd = @fopen($form["url"], "r");

					if ($url["size"]) {
						$return = @fread($fd, $url["size"]);
					} else {
						$return = @fread($fd,"100000");
					}

					@fclose($fd);
				}

				$time_stop = microtime();

				$time_start = explode(" ", $time_start);
				$time_stop = explode(" ", $time_stop);

				ereg("0\.([0-9]+)","".$time_start["0"], $time["1"]);
				ereg("0\.([0-9]+)","".$time_stop["0"], $time["2"]);

				$time_start = $time_start["1"].".".$time["1"]["1"];
				$time_stop = $time_stop["1"].".".$time["2"]["1"];

				if (!$url["size"]) {
					$url["size"] = strlen($return)/1024;
					$url["size"] = number_format($url["size"]*1000, 0, "", "");
				}

				$time_total = $time_stop-$time_start;
				$time_relaunch = $time_total/$form["relaunch"];

				$time_throughput = number_format($url["size"]/$time_relaunch/1024,3, "", "");
				$time_throughput = str_replace(".", "", $time_throughput);

				if ($time_throughput < 1048576) {
					$time_throughput = number_format($time_throughput/1024,1)." KB/s";
				} else {
					$time_throughput = $time_throughput/1048576;
					$time_throughput = number_format($time_throughput,1,",",".")." MB/s";
				}

				if ($url["size"] < 1048576) {
					$url["size"] = number_format($url["size"]/1024,1)." KB";
				} else {
					$url["size"] = $url["size"]/1048576;
					$url["size"] = number_format($url["size"],1,",",".")." MB";
				}

				$time_maximum = number_format(((60)/$time_relaunch),2,",",".");

				echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";

				echo "<tr><td width=\"180\">".$this->module_language["0595"].":</td><td>".$url["size"]."</td></tr>";
				echo "<tr><td width=\"180\">".$this->module_language["0596"].":</td><td>".number_format($time_total,3)." ".$this->module_language["0556"]."</td></tr>";
				echo "<tr><td width=\"180\">".$this->module_language["0597"].":</td><td>".number_format($time_relaunch,3)." ".$this->module_language["0556"]."</td></tr>";
				echo "<tr><td width=\"180\">".$this->module_language["0598"].":</td><td>".$time_throughput."</td></tr>";
				echo "<tr><td width=\"180\">".$this->module_language["0599"].":</td><td>".$time_maximum." ".$this->module_language["0600"]."</td></tr>";

				echo "</table>";

			} else {

				echo $this->module_language["0594"];

			}

			tablefooter();

		}

	}

	/*
		class contentpapst_gui_options::do_list_cache
	*/

	function do_list_cache() {

		GLOBAL $PHP_SELF, $file, $sql;

		tabletop($this->module_language["0557"]);
		echo $this->module_language["0558"];
		tablefooter();
		echo "<br />";

		form_moveonsite("$PHP_SELF?file=$file&mode=delete_cache&clean=yes", $this->module_language["0559"], "2");
		form_back("1");

	}

	/*
		class contentpapst_gui_options::do_delete_cache
	*/

	function do_delete_cache() {

		GLOBAL $PHP_SELF, $file;

		$path = "cache";

		$handle = opendir($path);
		while ($file_array = readdir($handle)) { $retVal[count($retVal)] = $file_array; }

		closedir($handle);
		sort($retVal);

		while (list($key, $val) = each($retVal)) {

			if ($val != "." AND $val != "..") {
				@unlink($path."/".$val);
			}

		}

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_set_cache
	*/

	function do_set_cache($form) {

		GLOBAL $PHP_SELF, $file, $sql;

		foreach($form AS $key => $value) {
			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = 'cache' AND module = '".db_escape_string($key)."'");
		}

		set_db_config();

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_list_active
	*/

	function do_list_active() {

		include_once("functions/cp.string.php");
		GLOBAL $PHP_SELF, $file, $sql, $themeadmin, $language;

		$module_array = $this->get_modules("modules");
		$row_count = 0;

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0614"]);

		echo "<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">";

		echo "<tr><td colspan=\"2\" align=\"left\">".$this->module_language["0615"]."<br /><br /></td></tr>";

		foreach($module_array AS $key => $value) {

			echo "<tr><td valign=\"top\" width=\"40\">";

			if ($module_array["$key"]["status"] == 0) {
				$module_array["$key"]["status"] = 2;
			}

			if ($module_array["$key"]["install"]) {

				echo "<a href=\"$PHP_SELF?file=".$file."&mode=install&module=".$key."\"><img src=\"themes/".$themeadmin."/images/install.gif\" border=\"0\" alt=\"\"/></a>";

			} else {

				$value_array = array("1"=>$this->module_language["0617"], "2"=>$this->module_language["0618"], "-1"=>$this->module_language["0619"]);

				echo "\n\n<select name=\"form[".$key."]\" class=\"inputmini\">\n";

				foreach ($value_array AS $key_2 => $value_2) {

					unset($selected);

					if ($module_array["$key"]["status"] == $key_2) {
						$selected = "selected=\"selected\"";
					}

					echo "\t<option value=\"".$key_2."\" $selected>".$value_2."</option>\n";

				}

				echo "</select>\n\n";

			}

			echo "</td><td align=\"left\">\n";

			if (file_exists("modules/".$key."/admin.php")) {
				$module["url"] = "admin.php";
			} else {
				$module["url"] = "index.php";
			}

			if (file_exists("modules/".$key."/languages/".$language."/index.php")) {

				include_once("modules/".$key."/languages/".$language."/index.php");

				$module["title"] = $lang["$key"]["module_title"];
				$module["desc"] = $lang["$key"]["module_desc"];
				$module["desc"] = substr($module["desc"],0,150)."...";

			} else {

				$module["title"] = $key;
				$module["desc"] = "<i>".$this->module_language["0616"]."</i>";

			}

			echo "<div style=\"font-weight: bold\"><a href=\"".$module["url"]."?file=".$key."\" onfocus=\"this.blur()\">".$module["title"]."</a></div>".$module["desc"]."<br /><br />\n\n";

			echo "</td></tr>\n\n";

		}

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "set_active");
		form_hidden("clean", "yes");

		form_send();
		form_stop();

		echo "&nbsp;";
		form_moveon("$PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_set_active
	*/

	function do_set_active($form) {

		GLOBAL $PHP_SELF, $file;

		foreach ($form AS $key => $value) {

			unset($content);

			@chmod("modules/".$key, 0777);
			@chmod("modules/".$key."/config.php", 0777);

			$fd = @fopen("modules/".$key."/config.php", "r");
			$content = @fread($fd, filesize("modules/".$key."/config.php"));
			@fclose($fd);

			$content = preg_replace("/\\\$module_config\[\"".$key."\"\]\[\"status\"\] = \"(.*){1}\";/iU", "\$module_config[\"".$key."\"][\"status\"] = \"$value\";", $content);

			$fp = @fopen("modules/".$key."/config.php", "w");
			@fwrite($fp, $content);
			@fclose($fp);

		}

		header("Location: $PHP_SELF?file=$file&mode=activate");

	}

	/*
		class contentpapst_gui_options::do_list_logging_now
	*/

	function do_list_logging_now($form) {
		GLOBAL $file;
		cp_form_tunnel("admin", array("file"=>$file, "mode"=>"list_logging", "form"=>$form));
	}

	/*
		class contentpapst_gui_options::do_list_logging
	*/

	function do_list_logging($form) {

		GLOBAL $PHP_SELF, $file, $sql, $language, $configuration;

		form_start("$PHP_SELF?file=$file");

		tabletop($this->module_language["0805"]);

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		if ($configuration["main"]["log_errors"]) {
			form_checkbox("form[log_errors]", "1", "1");
		} else {
			form_checkbox("form[log_errors]", "1", "0");
		}

		echo "</td><td align=\"left\"><strong>".$this->module_language["$file"]["0024"]."</strong><br />".$this->module_language["$file"]["0025"]."</td></tr>";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		if ($configuration["main"]["show_error"]) {
			form_checkbox("form[show_error]", "1", "1");
		} else {
			form_checkbox("form[show_error]", "1", "0");
		}

		echo "</td><td align=\"left\"><strong>".$this->module_language["$file"]["0019"]."</strong><br />".$this->module_language["$file"]["0020"]."</td></tr>";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		echo "<input type=\"checkbox\" value=\"1\" name=\"disabled[show_text]\" class=\"checkbox\" disabled=\"disabled\"/>";

		echo "</td><td align=\"left\"><strong>".$this->module_language["$file"]["0023"].":</strong> ";
		form_text("form[show_text]", "inputsmall", $configuration["main"]["show_text"], "60");

		echo "</td></tr>";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		echo "<input type=\"checkbox\" value=\"1\" name=\"disabled[email_error]\" class=\"checkbox\" disabled=\"disabled\"/>";

		echo "</td><td align=\"left\"><strong>".$this->module_language["$file"]["0021"].":</strong> ";
		form_text("form[email_error]", "inputsmall", $configuration["main"]["email_error"], "60");

		echo "<br />".$this->module_language["$file"]["0022"]."</td></tr>";

		echo "<tr><td width=\"$col_width\" valign=\"top\">";

		echo "<input type=\"checkbox\" value=\"1\" name=\"disabled[email_error]\" class=\"checkbox\" disabled=\"disabled\"/>";

		echo "</td><td align=\"left\"><strong>".$this->module_language["$file"]["0026"].":</strong> ";
		form_text("form[redirect_page]", "inputsmall", $configuration["main"]["redirect_page"], "60");

		echo "<br />".$this->module_language["$file"]["0027"]."</td></tr>";

		echo "</table>";

		tablefooter();
		echo "<br />";

		form_hidden("mode", "set_logging");
		form_hidden("clean", "yes");

		form_send();
		form_stop();

		echo "&nbsp;";
		form_moveonsite("$PHP_SELF?file=$file&mode=delete_log", $this->module_language["0808"], "2");

		form_moveon("$PHP_SELF?file=$file");

		echo "<br /><br />";
		tabletop($this->module_language["0813"]);

		form_start("$PHP_SELF?file=$file");

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";
		echo "<tr><td align=\"left\" valign=\"top\">";

		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";

		echo "<tr><td align=\"left\">".$this->module_language["main"]["category"].":</td><td align=\"left\">";

		$category_array = array(
										"1"=>$this->module_language["0809"],
										"2"=>$this->module_language["0812"],
										"3"=>$this->module_language["0810"],
										"4"=>$this->module_language["0806"],
										"11"=>$this->module_language["0822"],
										"14"=>$this->module_language["main"]["article"]
										);

		echo "<select name=\"form[type]\" class=\"inputsmall\">";

		if ($form["type"] == "all") {
			echo "\t<option value=\"all\" selected=\"selected\">".$this->module_language["0377"]."</option>\n";
		} else {
			echo "\t<option value=\"all\">".$this->module_language["0377"]."</option>\n";
		}

		echo "\t<option value=\"all\">---------------------------------------------</option>\n";

		foreach ($category_array AS $key => $value) {

			unset($selected);

			if ($form["type"] == $key) {
				$selected = " selected=\"selected\"";
			}

			if (in_array($key, array("14"))) {
				echo "\t<option value=\"all\">---------------------------------------------</option>\n";
			}

			echo "\t<option value=\"".$key."\"".$selected.">".$value."</option>\n";

		}

		echo "</select>";

		if ($form["type"] == "all") {
			unset($form["type"]);
		}

		echo "</td><td align=\"left\">".$this->module_language["main"]["date"].":</td><td align=\"left\">";

		$category_array = array(
										"1"=>$this->module_language["0814"],
										"2"=>$this->module_language["0815"],
										"3"=>$this->module_language["0816"],
										"4"=>$this->module_language->module_language["0817"]
										);

		echo "<select name=\"form[date]\" class=\"inputsmall\">";

		if ($form["type"] == "all") {
			echo "\t<option value=\"all\" selected=\"selected\">".$this->module_language["main"]["total"]."</option>\n";
		} else {
			echo "\t<option value=\"all\">".$this->module_language["main"]["total"]."</option>\n";
		}

		echo "\t<option value=\"all\">---------------------------------------------</option>\n";

		foreach ($category_array AS $key => $value) {

			unset($selected);

			if ($form["date"] == $key) {
				$selected = " selected=\"selected\"";
			}

			echo "\t<option value=\"".$key."\"".$selected.">".$value."</option>\n";

		}

		echo "</select>";

		if ($form["date"] == "all") {
			unset($form["date"]);
		}

		echo "</td><td>";

		form_hidden("mode", "list_logging_now");
		form_send();

		echo "</td></tr>";

		echo "</table>";

		echo "</td></tr>";
		echo "</table>";

		tablefooter();
		echo "<br />";

		$where_string = "";

		if ($form) {

			$form_string = "";

			foreach ($form AS $key => $value) {
				if ($key != "page") {
					$form_string .= "&form[".$key."]=".$value;
				}
			}

		}

		if ($form["type"] == "4") {
			$where_string .= "AND type >= '4' AND type <= '10' ";
		} elseif ($form["type"] >= "11" AND $form["type"] <= "13") {
			$where_string .= "AND type >= '11' AND type <= '13'";
		} elseif ($form["type"]) {
			$where_string .= "AND type = '".$form["type"]."' ";
		}

		if ($form["date"]) {

			$recent_date = time();
			$seconds_perday = 86400;

			if ($form["date"] == 1) {
				$form["date"] = $recent_date-$seconds_perday;
			} elseif ($form["date"] == 2) {
				$form["date"] = $recent_date-($seconds_perday*30);
			} elseif ($form["date"] == 3) {
				$form["date"] = $recent_date-($seconds_perday*60);
			} elseif ($form["date"] == 4) {
				$form["date"] = $recent_date-($seconds_perday*120);
			}

			$where_string .= "AND date > '".$form["date"]."' ";
		}

		if ($where_string) {
			$where_string = "WHERE ".substr($where_string,4);
		}

		$res = db_select("SELECT * FROM ".$sql."_log $where_string");
		$num_articles = db_num_rows($res);
		$perpage = 10;
		$pagenum = $num_articles/$perpage;

		if ($form["page"]) {
			$limit_start = $form["page"]*$perpage-$perpage;
		} else {
			$limit_start = "0";
		}

		if (!$order) {
			$order = "number";
		}

		if (!$dir) {
			$dir = "desc";
		}

		$result2 = db_select("SELECT * FROM ".$sql."_log $where_string ORDER by $order $dir LIMIT $limit_start,$perpage");
		$num_results = db_num_rows($result2);

		tabletop($this->module_language["main"]["overview"]);

		echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n\t";
		echo "<tr><td colspan=\"3\">\n\t\t";

		if ($num_results) {

			echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"2\" border=\"0\">";
			echo "<tr><td width=\"20\"><strong>".$this->module_language["main"]["id"]."</strong></td><td width=\"90\"><strong>".$this->module_language["0807"]."</strong></td><td width=\"80\"><strong>".$this->module_language["main"]["ip"]."</strong></td><td width=\"120\"><strong>".$this->module_language["main"]["date"]."</strong></td><td><strong>".$this->module_language["main"]["description"]."</strong></td></tr>\n";

			include_once("functions/cp.string.php");

			while ($row = db_fetch_array($result2, "assoc")) {

				if ($row["user"]) {

					$result_2 = db_select("SELECT username FROM ".$sql."_user WHERE number = '".$row["user"]."'");
					while ($row_2 = db_fetch_array($result_2, "assoc")) {
						$row["user"] = "<a href=\"$PHP_SELF?file=user&mode=edit_user&number=".$row["user"]."\">".$row_2["username"]."</a>";
					}

				} else {

					$row["user"] = $this->module_language["0265"];

				}

				$type_array = array(
											"1"=>$this->module_language["0809"],
											"3"=>$this->module_language["0810"]
										);

				if ($type_array[$row["type"]]) {

					$row["comment"] = $type_array[$row["type"]];

				} elseif ($row["type"] == 2) {

					$row["comment"] = $this->module_language["0812"].": ".str_replace("|", ", ", $row["comment"]);

				} elseif ($row["type"] == 11) {

					$row["comment"] = str_replace("USER", $row["comment"], $this->module_language["0821"]);

				} elseif ($row["type"] == 12) {

					$row["comment"] = str_replace("USER", $row["comment"], $this->module_language["0823"]);

				} elseif ($row["type"] == 14) {

					if (preg_match("/\|1/", $row["comment"])) {
						$string = $this->module_language["0960"];
					} elseif (preg_match("/\|2/", $row["comment"])) {
						$string = $this->module_language["0961"];
					}

					$row["comment"] = preg_replace("/\|(.*)/", "", $row["comment"]);

					$result_2 = db_select("SELECT title FROM ".$sql."_article WHERE number = '".$row["comment"]."' AND language = '".$language."' LIMIT 1");
					while ($row_2 = db_fetch_array($result_2,"assoc")) {
						$row["comment"] = "<a href=\"admin.php?file=article&mode=edit_article&number=".$row["comment"]."\">".$row_2["title"]."</a>";
					}

					$row["comment"] = str_replace("{cp:helper:title}", $row["comment"], $string);

				}

				echo "<tr><td width=\"20\" valign=\"top\">".$row["number"]."</td><td width=\"90\" valign=\"top\">".$row["user"]."</td><td width=\"80\" valign=\"top\">".$row["ip"]."</td><td width=\"120\" valign=\"top\">".date("d.m.Y - H:i:s",$row["date"])."</td><td valign=\"top\">".$row["comment"]."</td></tr>";

			}

			echo "</table></tr><tr><td> </td></tr>";

		} else {

			echo "<tr><td align=\"center\">".$this->module_language["0613"]."</td></tr>";

		}

		echo "</table>";

		form_stop();

		tablefooter();
		echo "</center>";

		if ($num_results) {

			echo "<br />";

			if ($pagenum > "1") {

				echo "<strong>".$this->module_language["user"]["pages"].":</strong> ";

				for ($i=1; $i < $pagenum+1; $i ++) {

					if (!$form["page"]) {
						$form["page"] = "1";
					}

					if ($form["page"] == $i) {
						echo "<strong>".$i."</strong> ";
					} else {
						echo "<a href=\"$PHP_SELF?file=$file&mode=list_logging&form[page]=".$i.$form_string."\" target=\"_self\">".$i."</a> ";
					}

				}

			}

		}

	}

	/*
		class contentpapst_gui_options::do_set_logging
	*/

	function do_set_logging($form) {

		GLOBAL $PHP_SELF, $file, $sql;

		$rights_array = array("log_errors", "show_error");

		foreach ($rights_array AS $key => $value) {
			if (!$form["$value"]) {
				$form["$value"] = "0";
			}
		}

		foreach($form AS $key => $value) {
			db_update("UPDATE ".$sql."_options SET value = '".db_escape_string($value)."' WHERE title = '".db_escape_string($key)."' AND module = 'main'");
		}

		set_db_config();
		setconfig();

		header("Location: $PHP_SELF?file=$file");

	}

	/*
		class contentpapst_gui_options::do_delete_log
	*/

	function do_delete_log() {

		GLOBAL $PHP_SELF, $file, $sql;

		db_delete("DELETE FROM ".$sql."_log");
		db_optimize($sql."_log");

		header("Location: $PHP_SELF?file=$file&mode=logging");

	}

	/*
		class contentpapst_gui_options::get_modules
	*/

	function get_modules($path) {

		$array_dirs = array();
		$handle = opendir($path);

		while ($file = readdir($handle)) { $retVal[count($retVal)] = $file; }

		closedir($handle);
		sort($retVal);

		while (list($key,$val) = each($retVal)) {

			$fname = "$path/$val";

			if (is_dir($fname) AND $val != "." AND $val != "..") {
				if (file_exists($fname."/config.php")) {
					include_once($fname."/config.php");
				}
			}
		}

		RETURN $module_config;

	}

	/*
		class contentpapst_gui_options::do_main
	*/

	function do_main() {

		GLOBAL $PHP_SELF, $file, $themeadmin;

		tabletop($this->module_language["main"]["overview"]);

		$template_content = cp_template_open("themes/".$themeadmin."/options_sections.htm");

		$options_array = array(
							$this->module_language["main"]["options_general"]=>"$PHP_SELF?file=$file&mode=list_general",
							$this->module_language["main"]["contact"]=>"$PHP_SELF?file=$file&mode=list_contact",
							$this->module_language["main"]["metatags"]=>"$PHP_SELF?file=$file&mode=list_metatags",
							$this->module_language["0540"]=>"$PHP_SELF?file=$file&mode=list_cache",
							$this->module_language["0090"]=>"$PHP_SELF?file=$file&mode=list_server",
							$this->module_language["0590"]=>"$PHP_SELF?file=$file&mode=list_speed",
							$this->module_language["0805"]=>"$PHP_SELF?file=$file&mode=list_logging"
						);

		foreach($options_array AS $key => $value) {

			$section_content = $template_content;
			$section_content = cp_template_replace($section_content, "cp:header", "<a href=\"".$value."\">".$key."</a><br />");
			cp_template_output($section_content);

		}

		tablefooter();

	}

}
?>